.LEFT MARGIN
.ifnot hlp
.HL 1 Indexing
Runoff can produce an index to your document.  To do this you must use the
_.INDEX command for each occurence of a keyword you wish to index.
.ifnot small
This does not automatically cause all occurences of a keyword to be
indexed.  The index facility is intended to
produce indexes not concordances.
Then when you wish to print the index, you use _.PRINT INDEX or _.DO INDEX.
.s
.endif small
.endif hlp
.helpc INDEX
.q _.INDEX [text] 
.qq _.X [text] 
.p.index  INDEX
takes the remaining text on the line as a keyword and adds it, along with the
current page number, to the internal index buffer. The command does not cause
a break. 
.ifnot small
If in FILL mode the index command must appear immediately after the
item to be indexed. If you are in NO FILL mode the index command must appear
immediately after the line containing the index item.  If the line is broken
because it is too long the index page number may be incorrect. 
Underlining, overstriking, and escape
sequences are not recognized in index keywords. These special features can not
be recognized because there is no rational way to alphabetize keywords if they
are used. A given keyword may be indexed more than once. If a keyword is
indexed more than one time on a page the extra times are ignored. 
.p;SEE also the commands _.ENABLE INDEXING and _.DISABLE INDEXING.
.if RSX .s.i5;ADDITIONAL HELP AVAILABLE: ENTRY DO PRINT
DELETE RESET format Subindex Autoindex optimization
.endif RSX
.helpd ENTRY
.endif small
.q _.ENTRY index term
.qq  _.Y index term
.p.x ENTRY
This puts an index term into the index, but doesn't include the current page
number.  This also requests optimization for subindex entries.
.ifnot small
.helpd DO
.endif small
.q _.DO INDEX [;][text] 
.qq  _.DX [;][text]
.p.x  DO INDEX  
This command clears the title and subtitle,
uses the text as a header, and starts a new page. 
Then the entire contents of the index buffer is printed and reset.
.ifnot small
This is equivalent to:
.i5;_.TITLE
.i5;_.SUBTITLE
.i5;_.FLUSH _.PAGE _.C; [text]
.i5;_.S 4 _.PRINT INDEX
.p;If no text is specified the INDEX is printed as the header.
.helpd PRINT
.endif small
.q _.PRINT INDEX ["entry"]
.qq  _.PX ["entry"]
.p.index  PRINT INDEX  
This prints the specified entry in the index buffer.  If no entry is specified
the entire index buffer is printed and reset.  
.ifnot small
The index buffer is not reset
if an entry is specified. The entry must be an index
term.  This term and all of its subindex terms will be printed. 
.helpd format
.p
Entries are printed in alphabetic order and are set against the left margin.
The chapter and subpage numbers are printed in the same format as specified by
the _.DISPLAY CHAPTER or _.DISPLAY SUBPAGE commands. Regular line spacing
is used, except that a new paragraph is formed between entries with different
first letter.  The entries of different first letter may be separated by non
zero paragraph spacing, and orphan lines at the end of the page are prevented
by the paragraph test page value. The paragraph indentation is used to indent
extra page numbers which can not fit on the line with the index entry. 
.P
If both FILL and JUSTIFY are enabled the entry is followed by ellipses
(#.#.#.#) and the page numbers are printed right justified with respect to the
current right margin. If FILL is disabled the ellipses are omitted.  If
JUSTIFY is disabled the page numbers will start 2 spaces after the index
entry, and no justification will occur. 
.i5;(The use of FILL and JUSTIFY as well as the paragraph spacing is not
the same as in DSR)
.helpd DELETE
.endif small
.q _.DELETE INDEX "entry"
.s.index DELETE>INDEX
This deletes an index entry from the index buffer.  
.ifnot small
The buffer is not
shortened, so no space is saved.
This command is useful in breaking up the index into several parts.
Each part may be printed separately by _.PRINT INDEX and the deleted.
Finally all of the remaining parts can be printed and the index buffer
reset.
.helpd RESET
.endif small
.q _.RESET INDEX
.s.index RESET>INDEX
This resets the index buffer so that it contains no entries.
.ifnot small
This is done automatically by _.DO INDEX or an unqualified _.PRINT INDEX.
.helpd Subindex
.s.c;SUBINDEX
.p.x Subindex
If the command _.FLAGS SUBINDEX is issued, then you may also subindex
terms. Each subindex item is marked by a subindex flag.  Each item
will appear indented by 2 extra spaces more than the previous item
when a _.PRINT INDEX command or _.DO INDEX is issued.
For example the following text:
.lm+5 .nf
_.FLAGS SUBINDEX
_.INDEX flags>substitute
_.INDEX flags>index
_.PRINT INDEX
.qq produces the following:
flags
  index      1
  substitute 1
.f.lm-5
.helpd Autoindex
.s.c;AUTOINDEX
.p.x Autoindex
Index terms may also be generated automatically without using the _.INDEX
command if the _.FLAGS INDEX command has been issued.  Any term preceeded by
an index flag (_>) will be automatically indexed.  For further information see:
FLAGS INDEX.  Autoindexing may not be done inside a _.TITLE, _.SUBTITLE, 
_.CHAPTER, _.APPENDIX,  or _.HEADER LEVEL command.
.helpd optimization
.p
The index is optimized for speed.  Essentially the index routine keeps 
internal quick
locate tables.  A table is kept for the main entries.  You control
whether tables are kept for subentries by using the _.ENTRY statement.
If you know that a large set of subindex entries will be made under
the entry NAMES then you should request optimization with the following
command:
.i5;_.ENTRY NAMES>
.p
This must precede any _.INDEX commands with the main entry NAMES.
If you do not wish optimization for subentries of NAMES then use
the command:
.i5;_.ENTRY NAMES
.p
The optimization applies to all levels of subindex entries.
For example:
.i5;_.ENTRY NAMES>Authors>British
.i5;_.ENTRY NAMES>Authors>American
.i5;_.X NAMES>Authors>French
.br
Will optimize all subentries under NAMES,Authors,British, and American.
Subentries under French will not be optimized.
The optimization sacrifices dynamic memory to improve
speed.  The number of subindex entries must be greater than 26 for
optimization to improve the execution speed.
.endif small
